<template>
  <section class="main-body-wrapper">
    <div class="container p-0">
      <div class="page-title">
        <h1>Mobile Verification Number</h1>
        <h2 class="sub-title">Please enter the verification code sent to your mobile phone.</h2>
      </div>
      <div class="form-wrapper">
        <div class="container-fluid">
          <div class="text-center">
            <div class="mobile-varification"></div>
          </div>
          <div class="w-100 py-5 px-2 text-center">
            <div class="w-100 text-center">
              <p class="varification-title">
                Please enter the verification code (OTP) sent to :
                <span>{{mobile}}</span>
              </p>
            </div>
            <form class="otp-box-wrapper text-center"  :class="error ? 'otp-box-wrapper-error' : ''"  v-on:submit.prevent="next">
              <input class="otp-input"
                ref="codeBox1"
                id="codeBox1"
                type="number"
                maxlength="1"
                @keyup="onKeyUpEvent(1, $event)"
                @focus="onFocusEvent(1)"
                v-model="otp[0]"
                onKeyPress="if(this.value.length==1) return false"
              >
              <input class="otp-input"
                id="codeBox2"
                type="number"
                maxlength="1"
                @keyup="onKeyUpEvent(2, $event)"
                @focus="onFocusEvent(2)"
                v-model="otp[1]"
                onKeyPress="if(this.value.length==1) return false"
              >
              <input class="otp-input"
                id="codeBox3"
                type="number"
                maxlength="1"
                @keyup="onKeyUpEvent(3, $event)"
                @focus="onFocusEvent(3)"
                v-model="otp[2]"
                onKeyPress="if(this.value.length==1) return false"
              >
              <input class="otp-input"
                id="codeBox4"
                type="number"
                maxlength="1"
                @keyup="onKeyUpEvent(4, $event)"
                @focus="onFocusEvent(4)"
                v-model="otp[3]"
                onKeyPress="if(this.value.length==1) return false"
              >
              <input class="otp-input"
                id="codeBox5"
                type="number"
                maxlength="1"
                @keyup="onKeyUpEvent(5, $event)"
                @focus="onFocusEvent(5)"
                v-model="otp[4]"
                onKeyPress="if(this.value.length==1) return false"
                required
              >
              <input class="otp-input"
                id="codeBox6"
                type="number"
                maxlength="1"
                @keyup="onKeyUpEvent(6, $event)"
                @focus="onFocusEvent(6)"
                v-model="otp[5]"
                onKeyPress="if(this.value.length==1) return false"
              >
             <p  class="text-left" v-if="error"><i  class="error-msg"  >Wrong code</i></p>
            </form>
             
            <div class="row m-0">
              <div class="col-lg-12 col-md-12 otp-submit-btn">
                <div class="continue-btn-wrap text-center">
                  <button
                    type="submit"
                    class="btn continue-btn"
                    :disabled="this.smsCode.length<6 || submitted"
                    @click.prevent="next"
                  >Continue</button>
                </div>
              <a class="resend-code d-block mt-3" @click="codepreview"><span class="resendcode" v-show="!resend">Didn't receive the SMS? Click here to resend</span></a>
              <div class="otp-box-wrapper  col-md-9" v-show="resend">
                  <div class="form-group">
                    <label for="phonenumber" class="text-left">
                      <span>Mobile Number</span>
                    </label>
                    <div class="input-wrapper ">
                      <input
                        v-model.lazy="$v.newMobile.$model" 
                        type="text"
                        class="form-control box"
                        :class="getValidationClass('newMobile')"
                        id="phonenumber"
                        placeholder="Mobile Number"
                        name="phonenumber"
                      >
                      <a class="resend-code" @click.prevent="resendSms" >Resend</a>

                      <span class="success-icon"  v-if="$v.newMobile.$dirty  && !$v.newMobile.$invalid">
                            <i class="fa fa-check-circle" aria-hidden="true"></i>
                      </span>
                      <span class="error-icon" v-if="$v.newMobile.$error">
                            <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                      </span>
                      <i class="error-msg text-left" v-if="$v.newMobile.$dirty && !$v.newMobile.required">Please enter Mobile Number</i>
                      <i class="error-msg text-left" v-else-if="$v.newMobile.$dirty && !$v.newMobile.minLength">Minimum 10 numbers required</i>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import { required, minLength } from "vuelidate/lib/validators"
import {NODE_ENV} from "../env.js"
export default {
  name: 'MobileCodeVerification',
  data () {
    return {
      token: localStorage.getItem('token'),
      submitted: false, //disable button when form submited
      mobile: localStorage.getItem("mobile"),
      newMobile: localStorage.getItem("mobile"),
      smsCode: '',
      otp: [],
      error: null,
      resend: false
    };
  }, 
  mounted() {
    if(NODE_ENV=='development'){
     var otp = localStorage.getItem("smsCode");
     this.otp = otp.split('');
    }
     setTimeout(() => { 
        this.$refs.codeBox1.focus();
     }, 10);
  },
  validations: {
      newMobile: {
        required,
        minLength: minLength(10)
      },
  },

  watch: {
    otp: function(val) {
      this.smsCode = this.otp.join("");
    }
  },
  
  methods: {
    //add this function to eacn page, and make to validate flowCompleted status
    checkFlowCompletion() { //auto executed
      //if flowCompleted == true redirect to approval (approved or not approved based on result)
    },
    codepreview() {
      this.resend=true
    },
    getValidationClass (fieldName) {
        const field = this.$v[fieldName]
        if (field) {
          return (field.$dirty && field.$invalid ? 'error-brdr' : ( field.$dirty && !field.$invalid  ? 'success-brdr' : '' ))
        }
    },
     back: function() {
      this.$router.push({"name": "InitiateAccount"})
    },
    next: function(event) {
      this.submitted=true //disable next button
      this.smsVerficiation()
    }, 
    smsVerficiation: function() {
      let data={
        "smsCode": this.smsCode
      };
      let settings = {
        "url": "/onboarding/accounts/sms",
        "method": "POST",
        "headers": {
          "content-type": "application/json",
          "authorization": "Bearer " + this.token,
        },
        "processData": false,
        "data":  data
      }
      
      this.$axios(settings)
        .then(response => {
          console.log("smsVerficiation response")
          console.log(response.data)
          if(response.data.status=="valid") {
            this.$store.commit('setStepProgress', {step:1,status:  'completed'})
            this.$router.push({"name": "MerchantType"})
          } else {
           // alert('wrong code')
            this.error=true
            this.submitted=false
          }
        })
        .catch(error => {
          this.submitted=false
          console.log('smsVerficiation.initiate.error-----------')
          let logObject = {module: "onboarding",error: error, details: {page: "mobileCodeVerification.smsVerficiation",endpoint: "/onboarding/accounts/sms",data: data}};
          this.$store.commit('logError', logObject);
        })
    },
    getCodeBoxElement(index) {
      return document.getElementById("codeBox" + index);
    },
    onKeyUpEvent(index, event) {
      const eventCode = event.which || event.keyCode;
      if (this.getCodeBoxElement(index).value.length === 1) {
        if (index !== 6) {
          this.getCodeBoxElement(index + 1).focus();
        } else {
          this.getCodeBoxElement(index).blur();
        }
      }
      if (eventCode === 8 && index !== 1) {
        this.getCodeBoxElement(index - 1).focus();
      }
    },
    onFocusEvent(index) {
      for (var item = 1; item < index; item++) {
        const currentElement = this.getCodeBoxElement(item);
        if (!currentElement.value) {
          currentElement.focus();
          break;
        }
      }
    },
    resendSms: function() {
      let that = this
      let data={
         "mobile": that.newMobile
      } 
      localStorage.setItem("mobile", that.newMobile),
      this.$axios({
        "url": "/onboarding/accounts/sms/resend",
        "method": "POST",
        "headers": { 
          "content-type": "application/json",
          "authorization": "Bearer " + this.token 
        },
        "data": data
      })
      .then(response => {
        console.log('resendSms is --- ',response);
        localStorage.setItem("smsCode", response.data.smsCode)
        this.$router.go()
        // this.$router.push({"name": "MobileCodeVerification"})
      })
      .catch(error => {
        let logObject = {module: "onboarding",error: error, details: {page: "mobileCodeVerification.resendSms",endpoint: "/onboarding/accounts/sms/resend",data: data}};
        this.$store.commit('logError', logObject);
      })
    }
  }
}
</script>

<style scoped>
.sms_code {
  font-size: 64px;
  text-align: center
}
</style>